/* Podatkovni tip Polje -- igralno polje za igro "4 v vrsto"
 *
 * uporaba:
 *  Polje a = new Polje(13,17);     -- naredi novo polje dimenzij 13x17
 *  Polje b = new Polje(a);         -- naredi novo polje, katerega dimenzije in
 *                                  -- barve celic so enake polju a
 *  int v = a.visina();             -- prebere visino polja
 *  int s = a.sirina();             -- prebere sirino polja
 *  a.izpisi();                     -- izpise polje na System.out
 *  a.dodaj(2, barva.bJaz);         -- najnizjo(!) prazno celico stolpca 2 pobarva
 *                                  -- z mojo barvo
 *  barva q = a.p(1, 2);            -- prebere barvo celice (1,2)
 *  barva r = a.polje[1][2];        -- identicno kot prejsna vrstica
 *  a.p(2, 3, barva.bNasprotnik);   -- celico (2,3) pobarva na bNasprotnik
 *  a.polje[2][3] = barva.bNasprotnik; -- identicno kot prejsna vrstica
 */

public class Polje {
    public barva[][] polje;

    Polje(int sirina, int visina) {
        polje = new barva[sirina][visina];
        for (int i=0;i<sirina;i++) {
            for (int j=0;j<visina;j++) {
                polje[i][j] = barva.bPrazna;
            }
        }
    }

    Polje(Polje r) {
        polje = new barva[r.sirina()][r.visina()];
        for (int i=0;i<r.sirina();i++)
            System.arraycopy(r.polje[i], 0, polje[i], 0, r.visina());
    }

    public int visina() {
        return polje[0].length;
    }

    public int sirina() {
        return polje.length;
    }

    void dodaj(int stolpec, barva b) throws Exception {
        if (stolpec == -1) return;
        for (int i=0;i<visina();i++) {
            if (polje[stolpec][i] == barva.bPrazna) {
                polje[stolpec][i] = b;
                return;
            }
        }
        throw new Exception("Stolpec je ze poln.");
    }

    void izpisi() {
        for (int y=visina()-1;y>=0;y--) {
            for (int x=0;x<sirina();x++) {
                switch(polje[x][y]) {
                    case bJaz: System.out.print("*"); break;
                    case bNasprotnik: System.out.print("o"); break;
                    case bPrazna: System.out.print(" "); break;
                }
            }
            System.out.println("");
        }
    }

    public barva p(int x, int y) {
        return polje[x][y];
    }

    public void p(int x, int y, barva b) {
        polje[x][y] = b;
    }
}
