import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;

class Comms {
    BufferedReader reader;
    PrintWriter writer;
}

public class SVVClient_j {
    public static void event_loop(Comms comms) throws Exception {

        Igralec t;
        Polje p;
        String cmd;
        String cmda[];

        while (true) {
            cmd = comms.reader.readLine();
            cmda = cmd.split(" ");

            if (cmda[0].equals("ADIJO")) return;
            if (cmda[0].startsWith("KONEC_IGRE")) continue;
            if (!cmda[0].equals("ZBUDI_SE")) throw new Exception("Napaka pri komunikaciji s streznikom.");

            int[] cmdi = new int[cmda.length - 1];
            for (int i=0;i<cmdi.length;i++) {
                cmdi[i] = Integer.parseInt(cmda[i+1]);
            }

            int w = cmdi[0];
            int h = cmdi[1];
            int z = cmdi[2];

            p = new Polje(w, h);
            t = new Igralec();
            t.ZbudiSe(w, h, z==0);

            comms.writer.format("BUDEN\n");
            comms.writer.flush();

            while (true) {
                cmd = comms.reader.readLine();
                cmda = cmd.split(" ");

                if (cmda[0].equals("ADIJO")) return;
                if (cmda[0].equals("KONEC_IGRE")) {
                    t.KonecIgre(Integer.parseInt(cmda[1]));
                    t = null;
                    p = null;
                    break;
                } else if (cmda[0].equals("QV")) {

                    int prejsnja_poteza = Integer.parseInt(cmda[1]);
                    p.dodaj(prejsnja_poteza, barva.bNasprotnik);
                    int stolpec = t.KamGres(new Polje(p), prejsnja_poteza);
                    p.dodaj(stolpec, barva.bJaz);

                    comms.writer.format("QVR %d\n", stolpec);
                    comms.writer.flush();
                } else {
                }
            }
        }
    }

    public static void connect(String Hostname, Comms comms) throws Exception {
        Socket client = new Socket(Hostname, 1177);

        comms.reader = new BufferedReader(new InputStreamReader(client.getInputStream()));
        comms.writer = new PrintWriter(new OutputStreamWriter(client.getOutputStream()));

        String server = comms.reader.readLine();
        System.out.println(server);

        comms.writer.println("AVE " + Igralec.Ime);
        comms.writer.flush();

        String succ = comms.reader.readLine();
        if (!succ.equals("PRIJAVA USPESNA")) throw new Exception("Prijava na streznik neuspesna" + succ);
    }

    public static void main(String argv[]) throws Exception {
        String Hostname;
        if (argv.length < 1) Hostname = "localhost";
        else Hostname = argv[0];

        Comms comms = new Comms();
        connect(Hostname, comms);
        event_loop(comms);

    }
}
